(function() {
  /*
  Copyright (c) 2002-2011 "Neo Technology,"
  Network Engine for Objects in Lund AB [http://neotechnology.com]
  
  This file is part of Neo4j.
  
  Neo4j is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; }, __hasProp = Object.prototype.hasOwnProperty, __extends = function(child, parent) {
    for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; }
    function ctor() { this.constructor = child; }
    ctor.prototype = parent.prototype;
    child.prototype = new ctor;
    child.__super__ = parent.prototype;
    return child;
  };
  define(['./models/Console', './models/HttpConsole', './views/ShellConsoleView', './views/GremlinConsoleView', './views/HttpConsoleView', 'ribcage/Router', 'lib/backbone'], function(Console, HttpConsole, ShellConsoleView, GremlinConsoleView, HttpConsoleView, Router) {
    var ConsoleRouter;
    return ConsoleRouter = (function() {
      __extends(ConsoleRouter, Router);
      function ConsoleRouter() {
        this.getConsoleView = __bind(this.getConsoleView, this);
        this.console = __bind(this.console, this);
        this.init = __bind(this.init, this);
        ConsoleRouter.__super__.constructor.apply(this, arguments);
      }
      ConsoleRouter.prototype.routes = {
        "/console/": "console",
        "/console/:type": "console"
      };
      ConsoleRouter.prototype.consoleType = "shell";
      ConsoleRouter.prototype.init = function(appState) {
        this.appState = appState;
        this.gremlinState = new Console({
          server: this.appState.get("server"),
          lang: "gremlin"
        });
        this.shellState = new Console({
          server: this.appState.get("server"),
          lang: "shell"
        });
        this.httpState = new HttpConsole({
          server: this.appState.get("server"),
          lang: "http"
        });
        return this.views = {
          gremlin: new GremlinConsoleView({
            appState: this.appState,
            consoleState: this.gremlinState,
            lang: "gremlin"
          }),
          shell: new ShellConsoleView({
            appState: this.appState,
            consoleState: this.shellState,
            lang: "shell"
          }),
          http: new HttpConsoleView({
            appState: this.appState,
            consoleState: this.httpState,
            lang: "http"
          })
        };
      };
      ConsoleRouter.prototype.console = function(type) {
        if (type == null) {
          type = false;
        }
        this.saveLocation();
        if (type === false) {
          type = this.consoleType;
        }
        this.consoleType = type;
        this.appState.set({
          mainView: this.getConsoleView(type)
        });
        return this.getConsoleView(type).focusOnInputField();
      };
      ConsoleRouter.prototype.getConsoleView = function(type) {
        return this.views[type];
      };
      return ConsoleRouter;
    })();
  });
}).call(this);
